#ifndef TOKENSTREAM_H
#define TOKENSTREAM_H

#include <stddef.h>
#include <stdbool.h>

#include "tokenizer/Token.h"

typedef struct TokenStream {
    size_t readIndex;
    size_t index;
    size_t length;
    char* buffer;
} TokenStream;

TokenStream* newTokenStream();
void deleteTokenStream(TokenStream** tokenStream);

bool hasToken(TokenStream* tokenStream);
void nextTokenString(TokenStream* tokenStream, char* buffer, size_t bufferLength);

Token nextToken(TokenStream* tokenStream);
unsigned int nextLine(TokenStream* tokenStream);
const char* nextString(TokenStream* tokenStream);
double nextDouble(TokenStream* tokenStream);

void addToken(TokenStream* tokenStream, Token token, unsigned int line);
void addDoubleToken(TokenStream* tokenStream, Token token, unsigned int line, double d);
void addStringToken(TokenStream* tokenStream, Token token, unsigned int line, const char* text);

#endif