#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "utils/Path.h"

void initPath(Path* path, const char* strPath) {
    path->capacity = PATH_MAX;
    path->usedCapacity = strlen(strPath) + 1;
    if(path->usedCapacity >= path->capacity) {
        path->usedCapacity = path->capacity;
    }
    strncpy(path->path, strPath, path->usedCapacity);
}

static bool path_add(Path* path, const char* add) {
    size_t addedLength = strlen(add);
    size_t freeSpace = path->capacity - path->usedCapacity;
    if(freeSpace < addedLength) {
        fprintf(stderr, "cannot add '%s' to '%s', buffer too small\n", add, path->path);
        return true;
    }
    strncpy(path->path + path->usedCapacity - 1, add, addedLength + 1);
    path->usedCapacity += addedLength;
    return false;
}

bool enterPath(Path* path, const char* object) {
    return path_add(path, "/") || path_add(path, object);
}

bool enterFile(Path* path, const char* object, const char* ending) {
    return path_add(path, "/") || path_add(path, object) || path_add(path, ending);
}

void leavePath(Path* path) {
    while(path->usedCapacity > 1 && path->path[path->usedCapacity - 1] != '/') {
        path->usedCapacity--;
    }
    path->path[path->usedCapacity - 1] = '\0';
}